classification
Title: test_multiprocessing_spawn altered the execution environment in AMD64 FreeBSD Non-Debug 3.x
Type: Stage: resolved
Components: Tests Versions: Python 3.9
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: pablogsal, vstinner
Priority: normal Keywords:

Created on 2019-11-18 23:39 by pablogsal, last changed 2021-07-13 19:52 by pablogsal. This issue is now closed.

Messages (7)
msg356929 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-11-18 23:39
Ran 352 tests in 243.972s
OK (skipped=34)
/usr/home/buildbot/python/3.x.koobs-freebsd-9e36.nondebug/build/Lib/multiprocessing/resource_tracker.py:203: UserWarning: resource_tracker: There appear to be 1 leaked shared_memory objects to clean up at shutdown
  warnings.warn('resource_tracker: There appear to be %d '
/usr/home/buildbot/python/3.x.koobs-freebsd-9e36.nondebug/build/Lib/multiprocessing/resource_tracker.py:216: UserWarning: resource_tracker: '/psm_5b8ca94b': [Errno 2] No such file or directory: '/psm_5b8ca94b'
  warnings.warn('resource_tracker: %r: %s' % (name, e))


1 test altered the execution environment:
    test_multiprocessing_spawn

It seems that the shared memory leaked is causing the test to fail. 
msg356930 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-11-18 23:40
https://buildbot.python.org/all/#builders/368/builds/98
msg356931 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-11-18 23:41
Another failure that seems related:

https://buildbot.python.org/all/#/builders/279/builds/136


Ran 168 tests in 154.704s
OK (skipped=3)
Warning -- multiprocessing.process._dangling was modified by test_concurrent_futures
  Before: set()
  After:  {<weakref at 0x7f48459bffb0; to 'SpawnProcess' at 0x7f48459baf00>}
msg356932 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2019-11-18 23:42
The last test may have a different explanation, though
msg356949 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-11-19 07:50
The build was marked as failed because of this warning:

https://buildbot.python.org/all/#/builders/368/builds/98

...
test_rlock (test.test_multiprocessing_spawn.WithProcessesTestLock) ... ok
test_enable_logging (test.test_multiprocessing_spawn.WithProcessesTestLogging) ... ok
test_level (test.test_multiprocessing_spawn.WithProcessesTestLogging) ... ok
test_rapid_restart (test.test_multiprocessing_spawn.WithProcessesTestManagerRestart) ... ok
Warning -- Dangling processes: {<SpawnProcess name='QueueManager-212' pid=13560 parent=12641 stopped exitcode=-SIGTERM>}

This warning is tracked as bpo-38447.
msg356950 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-11-19 07:52
AMD64 RHEL7 3.8 was marked as failed because of:
https://buildbot.python.org/all/#/builders/279/builds/136

test_max_workers_too_large (test.test_concurrent_futures.ProcessPoolSpawnProcessPoolExecutorTest) ... skipped 'Windows-only process limit'
test_no_stale_references (test.test_concurrent_futures.ProcessPoolSpawnProcessPoolExecutorTest) ... 0.57s ok
test_ressources_gced_in_workers (test.test_concurrent_futures.ProcessPoolSpawnProcessPoolExecutorTest) ... 1.78s ok
test_shutdown_race_issue12456 (test.test_concurrent_futures.ProcessPoolSpawnProcessPoolExecutorTest) ... 0.42s
Warning -- reap_children() reaped child process 11860
ok

The test_concurrent_futures reap_children() issue is tracked as bpo-38546.
msg356951 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-11-19 07:53
Pablo: Feel free to close this issue as duplicate, or leave it open to track the original "resource_tracker" warning.
History
Date User Action Args
2021-07-13 19:52:30pablogsalsetstatus: open -> closed
resolution: out of date
stage: resolved
2019-11-19 07:53:37vstinnersetmessages: + msg356951
2019-11-19 07:52:49vstinnersetmessages: + msg356950
2019-11-19 07:50:36vstinnersetnosy: + vstinner
messages: + msg356949
2019-11-18 23:42:24pablogsalsetmessages: + msg356932
2019-11-18 23:41:20pablogsalsetmessages: + msg356931
2019-11-18 23:40:27pablogsalsetmessages: + msg356930
2019-11-18 23:39:53pablogsalcreate